diff -crN nakedmudv1.0/src/admin.c nakedmudv1.4/src/admin.c
*** nakedmudv1.0/src/admin.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv1.4/src/admin.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 19,29 ****
  #include "action.h"
  #include "storage.h"
  
- // optional modules
- #ifdef MODULE_FACULTY
- #include "modules/faculty/faculty.h"
- #endif
- 
  
  //
  // BOOM! Shut down the MUD
--- 19,24 ----
***************
*** 94,101 ****
  //
  // Perform a copyover
  //
! COMMAND(cmd_copyover)
! { 
    FILE *fp;
    SOCKET_DATA *dsock;
    char buf[100];
--- 89,95 ----
  //
  // Perform a copyover
  //
! COMMAND(cmd_copyover) { 
    FILE *fp;
    SOCKET_DATA *dsock;
    char buf[100];
***************
*** 149,156 ****
  //
  // show a list of all the PCs who are linkdead
  //
! COMMAND(cmd_linkdead)
! {
    CHAR_DATA *xMob;
    char buf[MAX_BUFFER];
    bool found = FALSE;
--- 143,149 ----
  //
  // show a list of all the PCs who are linkdead
  //
! COMMAND(cmd_linkdead) {
    CHAR_DATA *xMob;
    char buf[MAX_BUFFER];
    bool found = FALSE;
***************
*** 168,170 ****
--- 161,171 ----
    if (!found)
      text_to_char(ch, "Noone is currently linkdead.\n\r");
  }
+ 
+ 
+ //
+ // List all of the non-player commands the character has access to
+ //
+ COMMAND(cmd_wizhelp) {
+   show_commands(ch, LEVEL_BUILDER, charGetLevel(ch));
+ }
diff -crN nakedmudv1.0/src/alias/alias.c nakedmudv1.4/src/alias/alias.c
*** nakedmudv1.0/src/alias/alias.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.4/src/alias/alias.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,224 ----
+ //*****************************************************************************
+ //
+ // alias.c
+ //
+ // Aliases allow a player to set up one command as another (e.g. "eat bread"
+ // as "food").
+ //
+ //*****************************************************************************
+ 
+ #include "../mud.h"
+ #include "../utils.h"
+ #include "../auxiliary.h"
+ #include "../storage.h"
+ #include "../character.h"
+ 
+ #include "alias.h"
+ 
+ // how many buckets are in the alias hashtable?
+ #define ALIAS_TABLE_SIZE           10
+ 
+ 
+ //*****************************************************************************
+ //
+ // auxiliary data
+ //
+ //*****************************************************************************
+ typedef struct alias_aux_data {
+   HASHTABLE *aliases;
+ } ALIAS_AUX_DATA;
+ 
+ 
+ ALIAS_AUX_DATA *
+ newAliasAuxData() {
+   ALIAS_AUX_DATA *data = malloc(sizeof(ALIAS_AUX_DATA));
+   //
+   // Hashtables can take up lots of storage space. Because of this, let's
+   // not create any tables until it's actually needed. This will cut down
+   // on lots of memory usage w.r.t. NPCs who do not use aliases
+   //  data->aliases        = newHashtable(ALIAS_TABLE_SIZE);
+   //
+   data->aliases        = NULL;
+   return data;
+ }
+ 
+ 
+ void
+ deleteAliasAuxData(ALIAS_AUX_DATA *data) {
+   if(data->aliases) {
+     HASH_ITERATOR *hash_i = newHashIterator(data->aliases);
+     const char     *alias = NULL;
+     char             *cmd = NULL;
+ 
+     ITERATE_HASH(alias, cmd, hash_i) 
+       free(cmd);
+     deleteHashIterator(hash_i);
+     deleteHashtable(data->aliases);
+   }
+   free(data);
+ }
+ 
+ 
+ void
+ aliasAuxDataCopyTo(ALIAS_AUX_DATA *from, ALIAS_AUX_DATA *to) {
+   // aliases are for personal use, and it is doubtful we would
+   // ever have a motivation for copying them over. Thus, we shall
+   // not do any copying here.
+ }
+ 
+ 
+ ALIAS_AUX_DATA *
+ aliasAuxDataCopy(ALIAS_AUX_DATA *data) {
+   // as with aliasAuxDataCopyTo, there seems to be little reason
+   // why we would ever want to copy aliases. They are personal,
+   // and have no reason for being copied. Thus, let us just return
+   // a new datastructure.
+   return newAliasAuxData();
+ }
+ 
+ 
+ STORAGE_SET *aliasAuxDataStore(ALIAS_AUX_DATA *data) {
+   // if we have no hashtable, return an empty set
+   if(data->aliases == NULL || hashSize(data->aliases) == 0)
+     return new_storage_set();
+ 
+   STORAGE_SET *set       = new_storage_set();
+   STORAGE_SET_LIST *list = new_storage_list();
+   HASH_ITERATOR  *hash_i = newHashIterator(data->aliases);
+   const char       *name = NULL;
+   const char        *cmd = NULL;
+ 
+   store_list(set, "aliases", list, NULL);
+   ITERATE_HASH(name, cmd, hash_i) {
+     STORAGE_SET *alias_set = new_storage_set();
+     store_string(alias_set, "key", name, NULL);
+     store_string(alias_set, "val", hashIteratorCurrentVal(hash_i), NULL);
+     storage_list_put(list, alias_set);
+   }
+   deleteHashIterator(hash_i);
+   return set;
+ }
+ 
+ 
+ ALIAS_AUX_DATA *aliasAuxDataRead(STORAGE_SET *set) {
+   // if the file contains no alias data, then don't load any
+   if(!storage_contains(set, "aliases"))
+     return newAliasAuxData();
+ 
+   ALIAS_AUX_DATA *data   = newAliasAuxData();
+   data->aliases          = newHashtable(ALIAS_TABLE_SIZE);
+   STORAGE_SET_LIST *list = read_list(set, "aliases");
+   STORAGE_SET *var       = NULL;
+ 
+   while( (var = storage_list_next(list)) != NULL)
+     hashPut(data->aliases, read_string(var, "key"), 
+ 	    strdup(read_string(var, "val")));
+   return data;
+ }
+ 
+ 
+ void init_aliases() {
+   // install aliases on the character datastructure
+   auxiliariesInstall("alias_aux_data",
+ 		     newAuxiliaryFuncs(AUXILIARY_TYPE_CHAR,
+ 				       newAliasAuxData, deleteAliasAuxData,
+ 				       aliasAuxDataCopyTo, aliasAuxDataCopy,
+ 				       aliasAuxDataStore, aliasAuxDataRead));
+ 
+   // allow people to view their aliases
+   add_cmd("alias", NULL, cmd_alias, 0, POS_UNCONCIOUS, POS_FLYING, 
+ 	  LEVEL_PLAYER, FALSE, TRUE);
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ //
+ // functions for interacting with character aliases
+ //
+ //*****************************************************************************
+ const char *charGetAlias(CHAR_DATA *ch, const char *alias) {
+   ALIAS_AUX_DATA *data = charGetAuxiliaryData(ch, "alias_aux_data");
+   if(data->aliases == NULL)
+     return NULL;
+   return hashGet(data->aliases, alias);
+ }
+ 
+ 
+ void charSetAlias(CHAR_DATA *ch, const char *alias, const char *cmd){
+   ALIAS_AUX_DATA *data = charGetAuxiliaryData(ch, "alias_aux_data");
+   // if our alias table is NULL, create a new one
+   if(data->aliases == NULL)
+     data->aliases = newHashtable(ALIAS_TABLE_SIZE);
+ 
+   // pull out the last one
+   char *oldcmd = hashRemove(data->aliases, alias);
+   if(oldcmd != NULL)
+     free(oldcmd);
+   // put in the new one if it exists
+   if(cmd && *cmd)
+     hashPut(data->aliases, alias, strdup(cmd));
+ }
+ 
+ 
+ char *expand_alias(const char *alias, const char *arg) {
+   char *cmd = strdup(alias);
+ 
+   // first, we replace all occurances of the numeric parameters
+   int i;
+   for(i = 1; i < 10; i++) {
+     char param[3];
+     char one_arg[SMALL_BUFFER];
+     sprintf(param, "$%d", i);
+     arg_num(arg, one_arg, i);
+     replace_string(&cmd, param, one_arg, TRUE);
+   }
+ 
+   // then we replace the wildcard
+   replace_string(&cmd, "$*", arg, TRUE);
+   return cmd;
+ }
+ 
+ 
+ //
+ // Set or delete an alias. If no argument is supplied, all aliases are listed.
+ //
+ COMMAND(cmd_alias) {
+   // list off all of the aliases
+   if(!arg || !*arg) {
+     ALIAS_AUX_DATA *data = charGetAuxiliaryData(ch, "alias_aux_data");
+     send_to_char(ch, "Current aliases:\r\n");
+     if(data->aliases == NULL || hashSize(data->aliases) == 0)
+       send_to_char(ch, "  none\r\n");
+     else {
+       HASH_ITERATOR *alias_i = newHashIterator(data->aliases);
+       const char      *alias = NULL;
+       const char        *cmd = NULL;
+ 
+       ITERATE_HASH(alias, cmd, alias_i)
+ 	send_to_char(ch, "  %-20s %s\r\n", alias, cmd);
+       deleteHashIterator(alias_i);
+     }
+   }
+   else {
+     char alias[SMALL_BUFFER];
+     arg = one_arg(arg, alias);
+ 
+     // try to delete an alias
+     if(!arg || !*arg) {
+       const char *curr_cmd = charGetAlias(ch, alias);
+       if(!curr_cmd)
+ 	send_to_char(ch, "You do not have such an alias.\r\n");
+       else {
+ 	charSetAlias(ch, alias, arg);
+ 	send_to_char(ch, "Alias deleted.\r\n");
+       }
+     }
+ 
+     // try to set an alias
+     else {
+       charSetAlias(ch, alias, arg);
+       send_to_char(ch, "Alias set.\r\n");
+     }
+   }
+ }
diff -crN nakedmudv1.0/src/alias/alias.h nakedmudv1.4/src/alias/alias.h
*** nakedmudv1.0/src/alias/alias.h	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.4/src/alias/alias.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,38 ----
+ #ifndef __ALIAS_H
+ #define __ALIAS_H
+ //*****************************************************************************
+ //
+ // alias.h
+ //
+ // Aliases allow a player to set up one command as another (e.g. "eat bread"
+ // as "food").
+ //
+ //*****************************************************************************
+ 
+ //
+ // This must be put at the top of mud.h so the rest of the MUD knows that
+ // we've got the alias module installed
+ // #define MODULE_ALIAS
+ //
+ 
+ //
+ // prepare aliases for use
+ //
+ void init_aliases();
+ 
+ const char  *charGetAlias  (CHAR_DATA *ch, const char *alias);
+ void         charSetAlias  (CHAR_DATA *ch, const char *alias, const char *cmd);
+ 
+ //
+ // expand an alias's parameters with the arguments provided. Returned
+ // string must be freed after being used.
+ //
+ char *expand_alias(const char *alias, const char *arg);
+ 
+ //
+ // list all of a character's aliases to him
+ //
+ COMMAND(cmd_alias);
+ 
+ 
+ #endif // __ALIAS_H
diff -crN nakedmudv1.0/src/alias/.depend nakedmudv1.4/src/alias/.depend
*** nakedmudv1.0/src/alias/.depend	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.4/src/alias/.depend	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1 ----
+ alias.o: alias.c alias.h
diff -crN nakedmudv1.0/src/alias/module.mk nakedmudv1.4/src/alias/module.mk
*** nakedmudv1.0/src/alias/module.mk	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.4/src/alias/module.mk	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,2 ----
+ # src files we have
+ SRC   += alias/alias.c
diff -crN nakedmudv1.0/src/body.c nakedmudv1.4/src/body.c
*** nakedmudv1.0/src/body.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv1.4/src/body.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 22,28 ****
  typedef struct bodypart_data   BODYPART;
  
  struct body_data {
!   LIST *parts;               // a list of all the parts on the body
  };
  
  
--- 22,29 ----
  typedef struct bodypart_data   BODYPART;
  
  struct body_data {
!   LIST   *parts;             // a list of all the parts on the body
!   int      size;             // how big is our body?
  };
  
  
***************
*** 61,66 ****
--- 62,79 ----
    "dragon",
  };
  
+ const char *bodysize_list[NUM_BODYSIZES] = {
+   "diminuitive",
+   "tiny",
+   "small",
+   "medium",
+   "large",
+   "huge",
+   "gargantuan",
+   "collosal"
+ };
+ 
+ 
  /**
   * Create a new bodypart_data
   */
***************
*** 100,105 ****
--- 113,119 ----
   */
  BODY_DATA *newDragonBody() {
    BODY_DATA *body = newBody();
+   body->size = BODYSIZE_COLLOSAL;
    bodyAddPosition(body, "left hind claw",          BODYPOS_CLAW,          1);
    bodyAddPosition(body, "right hind claw",         BODYPOS_CLAW,          1);
    bodyAddPosition(body, "left front claw",         BODYPOS_CLAW,          1);
***************
*** 126,131 ****
--- 140,146 ----
   */
  BODY_DATA *newHumanoidBody() {
    BODY_DATA *body = newBody();
+   body->size = BODYSIZE_MEDIUM;
    bodyAddPosition(body, "right grip",              BODYPOS_HELD,          0);
    bodyAddPosition(body, "left grip",               BODYPOS_HELD,          0);
    bodyAddPosition(body, "right foot",              BODYPOS_RIGHT_FOOT,    2);
***************
*** 193,198 ****
--- 208,225 ----
    return BODYTYPE_NONE;
  }
  
+ const char *bodysizeGetName(int size) {
+   return bodysize_list[size];
+ }
+ 
+ int bodysizeGetNum(const char *size) {
+   int i;
+   for(i = 0; i < NUM_BODYSIZES; i++)
+     if(!strcasecmp(size, bodysize_list[i]))
+       return i;
+   return BODYSIZE_NONE;
+ }
+ 
  const char *bodyposGetName(int bodypos) {
    return bodypos_list[bodypos];
  }
***************
*** 232,241 ****
--- 259,273 ----
    BODY_DATA *Bnew = newBody();
    deleteListWith(Bnew->parts, deleteBodypart);
    Bnew->parts = listCopyWith(B->parts, bodypartCopy);
+   Bnew->size  = B->size;
  
    return Bnew;
  }
  
+ int bodyGetSize(const BODY_DATA *B) {
+   return B->size;
+ }
+ 
  //
  // Find a bodypart on the body with the given name
  //
diff -crN nakedmudv1.0/src/body.h nakedmudv1.4/src/body.h
*** nakedmudv1.0/src/body.h	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv1.4/src/body.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 44,49 ****
--- 44,59 ----
  
  #define NUM_BODYTYPES             2
  
+ #define BODYSIZE_NONE            -1
+ #define BODYSIZE_DIMINUITIVE      0
+ #define BODYSIZE_TINY             1
+ #define BODYSIZE_SMALL            2
+ #define BODYSIZE_MEDIUM           3
+ #define BODYSIZE_LARGE            4
+ #define BODYSIZE_HUGE             5
+ #define BODYSIZE_GARGANTUAN       6
+ #define BODYSIZE_COLLOSAL         7
+ #define NUM_BODYSIZES             8
  
  /**
   * Return a list of the postypes for a list of posnames (comma-separated)
***************
*** 70,75 ****
--- 80,97 ----
  
  
  /**
+  * return the name of the specified bodysize
+  */
+ const char *bodysizeGetName(int size);
+ 
+ 
+ /**
+  * return the number assocciated with the bodysize
+  */
+ int bodysizeGetNum(const char *size);
+ 
+ 
+ /**
   * returns the number of the bodyposition
   */
  int bodyposGetNum(const char *bodypos);
***************
*** 101,106 ****
--- 123,134 ----
  
  
  /**
+  * Return the size of the body
+  */
+ int bodyGetSize(const BODY_DATA *B);
+ 
+ 
+ /**
   * Add a new position to the body. <type> is one of the basic
   * position types listed at the start of this header, and
   * <weight> is how much of the body's mass the piece takes up,
diff -crN nakedmudv1.0/src/builder.c nakedmudv1.4/src/builder.c
*** nakedmudv1.0/src/builder.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv1.4/src/builder.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 26,33 ****
  
  // optional modules
  #ifdef MODULE_SCRIPTS
! #include "modules/scripts/script.h"
! #include "modules/scripts/script_set.h"
  #endif
  
  
--- 26,33 ----
  
  // optional modules
  #ifdef MODULE_SCRIPTS
! #include "scripts/script.h"
! #include "scripts/script_set.h"
  #endif
  
  
***************
*** 268,286 ****
      message(ch, NULL, NULL, NULL, FALSE, TO_NOTCHAR,
  	    "$n raises $s arms, and white flames engulf the entire room.");
  
!     // purge all the objects. We can't use ITERATE_LIST because
!     // we extract the current list element
!     obj = listIteratorCurrent(list_i);
!     while( (obj = listIteratorCurrent(list_i)) != NULL) {
!       listIteratorNext(list_i);
        extract_obj(obj);
-     }
      deleteListIterator(list_i);
  
      // and now all of the non-characters
      list_i = newListIterator(roomGetCharacters(charGetRoom(ch)));
!     while( (vict = listIteratorCurrent(list_i)) != NULL) {
!       listIteratorNext(list_i);
        if(vict == ch || !charIsNPC(vict)) 
  	continue;
        char_from_room(vict);
--- 268,281 ----
      message(ch, NULL, NULL, NULL, FALSE, TO_NOTCHAR,
  	    "$n raises $s arms, and white flames engulf the entire room.");
  
!     // purge all the objects. 
!     ITERATE_LIST(obj, list_i)
        extract_obj(obj);
      deleteListIterator(list_i);
  
      // and now all of the non-characters
      list_i = newListIterator(roomGetCharacters(charGetRoom(ch)));
!     ITERATE_LIST(vict, list_i) {
        if(vict == ch || !charIsNPC(vict)) 
  	continue;
        char_from_room(vict);
***************
*** 391,396 ****
--- 386,392 ----
    }
  }
  
+ 
  #ifdef MODULE_SCRIPTS
  COMMAND(cmd_sclist) {
    do_list(ch, zoneGetScript, scriptGetName, scriptGetType, scriptTypeName,
diff -crN nakedmudv1.0/src/character.c nakedmudv1.4/src/character.c
*** nakedmudv1.0/src/character.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv1.4/src/character.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 2,16 ****
  //
  // character.c
  //
! // implementation of the character datastructure (PCs and NPCs)
  //
  //*****************************************************************************
- 
  #include "mud.h"
- #include "socket.h"
  #include "utils.h"
  #include "body.h"
- #include "log.h"
  #include "races.h"
  #include "handler.h"
  #include "auxiliary.h"
--- 2,19 ----
  //
  // character.c
  //
! // Basic implementation of the character datastructure (PCs and NPCs). Includes
! // data for storing room, inventory, body, equipment, and other "essential"
! // information. If you plan on adding any other information to characters, it
! // is strongly suggested you do so through auxiliary data (see auxiliary.h).
! //
! // For a recap, IF YOU PLAN ON ADDING ANY OTHER INFORMATION TO CHARACTERS, IT
! // IS STRONGLY SUGGESTED YOU DO SO THROUGH AUXILIARY DATA (see auxiliary.h).
  //
  //*****************************************************************************
  #include "mud.h"
  #include "utils.h"
  #include "body.h"
  #include "races.h"
  #include "handler.h"
  #include "auxiliary.h"
***************
*** 19,31 ****
  #include "character.h"
  
  
- // probably good to increase this if your MUD relies heavily on spec_vars
- #define SPEC_VAR_TABLE_SIZE      10
- 
  // mob UIDs (unique IDs) start at a million and go 
  // up by one every time a new NPC is created
! #define START_MOB_UID   (1000000)
! int next_mob_uid  = START_MOB_UID;
  
  const char *sex_names[NUM_SEXES] = {
    "male",
--- 22,31 ----
  #include "character.h"
  
  
  // mob UIDs (unique IDs) start at a million and go 
  // up by one every time a new NPC is created
! #define START_MOB_UID       1000000
! int next_mob_uid  =   START_MOB_UID;
  
  const char *sex_names[NUM_SEXES] = {
    "male",
***************
*** 110,117 ****
    int                    position;
  
    LIST                 * inventory;
-   HASHTABLE            * spec_vars;
-   HASHTABLE            * aliases;
    HASHTABLE            * auxiliary_data;
  
    // data for NPCs only
--- 110,115 ----
***************
*** 153,160 ****
    ch->dialog        = NOTHING;
    ch->vnum          = NOBODY;
  
-   ch->spec_vars      = newHashtable(SPEC_VAR_TABLE_SIZE);
-   ch->aliases        = newHashtable(10);
    ch->auxiliary_data = newAuxiliaryData(AUXILIARY_TYPE_CHAR);
  
    return ch;
--- 151,156 ----
***************
*** 167,215 ****
  // utility functions
  //
  //*****************************************************************************
- void text_to_char(CHAR_DATA *ch, const char *txt)
- {
-   if (ch->socket && socketGetState(ch->socket) == STATE_PLAYING && txt && *txt){
-     text_to_buffer(ch->socket, txt);
-     ch->socket->bust_prompt = TRUE;
-   }
- 
-   // if it's a PC or we are not in game, then
-   // don't send the mesage to us
-   if(!charIsNPC(ch))
-     try_log(charGetName(ch), txt);
- }
- 
- void send_to_char(CHAR_DATA *ch, const char *format, ...) {
-   if(ch->socket && format && *format) {
-     static char buf[MAX_BUFFER];
-     va_list args;
-     va_start(args, format);
-     vsprintf(buf, format, args);
-     va_end(args);
-     text_to_char(ch, buf);
-     return;
-   }
- };
- 
- void send_to_list(LIST *list, const char *format, ...) {
-   if(format && *format) {
-     // form the message
-     static char buf[MAX_BUFFER];
-     va_list args;
-     va_start(args, format);
-     vsprintf(buf, format, args);
-     va_end(args);
- 
-     // send it out to everyone
-     LIST_ITERATOR *list_i = newListIterator(list);
-     CHAR_DATA *ch = NULL;
-     ITERATE_LIST(ch, list_i)
-       text_to_char(ch, buf);
-     deleteListIterator(list_i);
-   }
- };
- 
  void charSetRdesc(CHAR_DATA *ch, const char *rdesc) {
    if(ch->rdesc) free(ch->rdesc);
    ch->rdesc =   strdup(rdesc ? rdesc : "");
--- 163,168 ----
***************
*** 340,357 ****
    return ch->loadroom;
  }
  
- HASHTABLE   *charGetVars  ( CHAR_DATA *ch) {
-   return ch->spec_vars;
- }
- 
- HASHTABLE   *charGetAliases  ( CHAR_DATA *ch) {
-   return ch->aliases;
- }
- 
- const char   *charGetAlias  ( CHAR_DATA *ch, const char *alias) {
-   return hashGet(ch->aliases, alias);
- }
- 
  void *charGetAuxiliaryData(const CHAR_DATA *ch, const char *name) {
    return hashGet(ch->auxiliary_data, name);
  }
--- 293,298 ----
***************
*** 360,369 ****
    return ch->furniture;
  }
  
- int          charGetVarVal( CHAR_DATA *ch, const char *var) {
-   return (int)hashGet(ch->spec_vars, var);
- }
- 
  void         charSetSocket    ( CHAR_DATA *ch, SOCKET_DATA *socket) {
    ch->socket = socket;
  };
--- 301,306 ----
***************
*** 415,430 ****
    ch->uid = uid;
  }
  
- void         charSetAlias  (CHAR_DATA *ch, const char *alias, const char *cmd){
-   // pull out the last one
-   char *oldcmd = hashRemove(ch->aliases, alias);
-   if(oldcmd != NULL)
-     free(oldcmd);
-   // put in the new one if it exists
-   if(cmd && *cmd)
-     hashPut(ch->aliases, alias, strdup(cmd));
- }
- 
  void         charResetBody(CHAR_DATA *ch) {
    charSetBody(ch, raceCreateBody(ch->race));
  }
--- 352,357 ----
***************
*** 437,455 ****
    ch->furniture = furniture;
  }
  
- void charSetVar( CHAR_DATA *ch, const char *var, int val) {
-   // make sure the varname has no spaces
-   if(strstr(var, " ") != NULL) {
-     log_string("ERROR: On %s, attempted to edit a variable with a space, '%s'",
- 	       charGetName(ch), var);
-     return;
-   }
- 
-   if(val == 0)
-     hashRemove(ch->spec_vars, var);
-   else
-     hashPut(ch->spec_vars, var, (void *)val);
- }
  
  
  //*****************************************************************************
--- 364,369 ----
***************
*** 480,558 ****
    if(mob->keywords)    free(mob->keywords);
    deleteAuxiliaryData(mob->auxiliary_data);
  
-   if(mob->spec_vars)   deleteHashtable(mob->spec_vars);
-   if(mob->aliases) {
-     HASH_ITERATOR *hash_i = newHashIterator(mob->aliases);
-     const char     *alias = NULL;
-     char             *cmd = NULL;
-     while( (alias = hashIteratorCurrentKey(hash_i)) != NULL) {
-       hashIteratorNext(hash_i);
-       cmd = hashRemove(mob->aliases, alias);
-       free(cmd);
-     }
-     deleteHashIterator(hash_i);
-     deleteHashtable(mob->aliases);
-   }
    free(mob);
  }
  
- STORAGE_SET *aliasStore(HASHTABLE *table) {
-   STORAGE_SET *set       = new_storage_set();
-   HASH_ITERATOR *hash_i  = newHashIterator(table);
-   STORAGE_SET_LIST *list = new_storage_list();
-   const char  *aliasname = NULL;
- 
-   store_list(set, "list", list, NULL);
-   while( (aliasname = hashIteratorCurrentKey(hash_i)) != NULL) {
-     STORAGE_SET *aliasset = new_storage_set();
-     store_string(aliasset, "key", aliasname, NULL);
-     store_string(aliasset, "val", hashIteratorCurrentVal(hash_i), NULL);
-     hashIteratorNext(hash_i);
-     storage_list_put(list, aliasset);
-   }
-   deleteHashIterator(hash_i);
-   return set;
- }
- 
- HASHTABLE *aliasRead(STORAGE_SET *set) {
-   HASHTABLE *table       = newHashtable(10);
-   STORAGE_SET_LIST *list = read_list(set, "list");
-   STORAGE_SET *var       = NULL;
- 
-   while( (var = storage_list_next(list)) != NULL)
-     hashPut(table, read_string(var, "key"), strdup(read_string(var, "val")));
-   return table;
- }
- 
- 
- STORAGE_SET *variableStore(HASHTABLE *table) {
-   STORAGE_SET *set       = new_storage_set();
-   HASH_ITERATOR *hash_i  = newHashIterator(table);
-   STORAGE_SET_LIST *list = new_storage_list();
-   const char    *varname = NULL;
- 
-   store_list(set, "list", list, NULL);
-   while( (varname = hashIteratorCurrentKey(hash_i)) != NULL) {
-     STORAGE_SET *varset = new_storage_set();
-     store_string(varset, "key", varname, NULL);
-     store_int   (varset, "val", (int)hashIteratorCurrentVal(hash_i), NULL);
-     hashIteratorNext(hash_i);
-     storage_list_put(list, varset);
-   }
-   deleteHashIterator(hash_i);
-   return set;
- }
- 
- HASHTABLE *variableRead(STORAGE_SET *set) {
-   HASHTABLE *table       = newHashtable(SPEC_VAR_TABLE_SIZE);
-   STORAGE_SET_LIST *list = read_list(set, "list");
-   STORAGE_SET *var       = NULL;
- 
-   while( (var = storage_list_next(list)) != NULL)
-     hashPut(table, read_string(var, "key"), (void *)read_int(var, "val"));
-   return table;
- }
- 
  
  CHAR_DATA *charRead(STORAGE_SET *set) {
    CHAR_DATA *mob = newMobile();
--- 394,402 ----
***************
*** 575,584 ****
      charSetLoadroom(mob,   read_int   (set, "loadroom"));
      charSetPos(mob,        read_int   (set, "position"));
      mob->prfs = parse_bits(read_string(set, "prfs"));
-     deleteHashtable(mob->spec_vars);
-     mob->spec_vars = variableRead(read_set(set, "variables"));
-     deleteHashtable(mob->aliases);
-     mob->aliases  = aliasRead(read_set(set, "aliases"));
    }
    // and NPC data
    else
--- 419,424 ----
***************
*** 587,592 ****
--- 427,436 ----
    deleteAuxiliaryData(mob->auxiliary_data);
    mob->auxiliary_data = auxiliaryDataRead(read_set(set, "auxiliary"), 
  					  AUXILIARY_TYPE_CHAR);
+ 
+   // reset our body to the default for our race
+   charResetBody(mob);
+ 
    return mob;
  }
  
***************
*** 611,618 ****
      store_string(set, "password",   mob->password,                 NULL);
      store_int   (set, "uid",        mob->uid,                      NULL);
      store_int   (set, "loadroom",   roomGetVnum(charGetRoom(mob)), NULL);
-     store_set   (set, "variables",  variableStore(mob->spec_vars), NULL);
-     store_set   (set, "aliases",    aliasStore(mob->aliases),      NULL);
    }
    // NPC-only data
    else
--- 455,460 ----
diff -crN nakedmudv1.0/src/character.h nakedmudv1.4/src/character.h
*** nakedmudv1.0/src/character.h	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv1.4/src/character.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 4,35 ****
  //
  // character.h
  //
! // the structures and functions needed for working with PCs and NPCs
  //
  //*****************************************************************************
  
  
- 
- 
  //
  // the difference between newChar and newMobile is that newMobile
  // assigned a new UID whereas newChar does not.
  //
! CHAR_DATA   *newChar           ();
! CHAR_DATA    *newMobile         ();
! void         deleteChar      (CHAR_DATA *mob);
  
! CHAR_DATA    *charRead          (STORAGE_SET *set);
! STORAGE_SET *charStore         (CHAR_DATA *mob);
  
- CHAR_DATA    *charCopy          (CHAR_DATA *mob);
- void         charCopyTo        (CHAR_DATA *from, CHAR_DATA *to);
  
  
- bool         charIsNPC        ( CHAR_DATA *ch);
- bool         charIsName       ( CHAR_DATA *ch, const char *name);
- void         putCharInventory ( CHAR_DATA *ch, OBJ_DATA *obj);
- void         charResetBody    ( CHAR_DATA *ch);
  
  //*****************************************************************************
  //
--- 4,40 ----
  //
  // character.h
  //
! // Basic implementation of the character datastructure (PCs and NPCs). Includes
! // data for storing room, inventory, body, equipment, and other "essential"
! // information. If you plan on adding any other information to characters, it
! // is strongly suggested you do so through auxiliary data (see auxiliary.h).
! //
! // For a recap, IF YOU PLAN ON ADDING ANY OTHER INFORMATION TO CHARACTERS, IT
! // IS STRONGLY SUGGESTED YOU DO SO THROUGH AUXILIARY DATA (see auxiliary.h).
  //
  //*****************************************************************************
  
  
  //
  // the difference between newChar and newMobile is that newMobile
  // assigned a new UID whereas newChar does not.
  //
! CHAR_DATA   *newChar          ();
! CHAR_DATA    *newMobile       ();
! void         deleteChar       (CHAR_DATA *mob);
! 
! CHAR_DATA    *charRead        (STORAGE_SET *set);
! STORAGE_SET *charStore        (CHAR_DATA *mob);
  
! CHAR_DATA    *charCopy        (CHAR_DATA *mob);
! void         charCopyTo       (CHAR_DATA *from, CHAR_DATA *to);
  
  
+ bool         charIsNPC        (CHAR_DATA *ch);
+ bool         charIsName       (CHAR_DATA *ch, const char *name);
+ void         putCharInventory (CHAR_DATA *ch, OBJ_DATA *obj);
+ void         charResetBody    (CHAR_DATA *ch);
  
  
  //*****************************************************************************
  //
***************
*** 38,46 ****
  //*****************************************************************************
  
  /* buffers the output        */
! void  text_to_char        ( CHAR_DATA *dMob, const char *txt );
! void  send_to_char          ( CHAR_DATA *ch, const char *format, ...);
! void  send_to_list          ( LIST *list, const char *format, ...);
  
  
  //*****************************************************************************
--- 43,53 ----
  //*****************************************************************************
  
  /* buffers the output        */
! void  text_to_char          (CHAR_DATA *dMob, const char *txt );
! void  send_to_char          (CHAR_DATA *ch, const char *format, ...) 
! __attribute__ ((format (printf, 2, 3)));
! void  send_to_list          (LIST *list, const char *format, ...) 
! __attribute__ ((format (printf, 2, 3)));
  
  
  //*****************************************************************************
***************
*** 56,62 ****
  const char  *charGetRdesc     ( CHAR_DATA *ch);
  const char  *charGetMultiRdesc( CHAR_DATA *ch);
  const char  *charGetMultiName ( CHAR_DATA *ch);
- const char  *charGetAlias     ( CHAR_DATA *ch, const char *alias);
  int          charGetLevel     ( CHAR_DATA *ch);
  int          charGetSex       ( CHAR_DATA *ch);
  bitvector_t  charGetBits      ( CHAR_DATA *ch, int field);
--- 63,68 ----
***************
*** 67,77 ****
  int          charGetRace      ( CHAR_DATA *ch);
  int          charGetUID       ( CHAR_DATA *ch);
  room_vnum    charGetLoadroom  ( CHAR_DATA *ch);
- HASHTABLE   *charGetVars      ( CHAR_DATA *ch);
- HASHTABLE   *charGetAliases   ( CHAR_DATA *ch);
  OBJ_DATA    *charGetFurniture ( CHAR_DATA *ch);
  int          charGetPos       ( CHAR_DATA *ch);
- int          charGetVarVal    ( CHAR_DATA *ch, const char *var);
  void        *charGetAuxiliaryData(const CHAR_DATA *ch, const char *name);
  
  void         charSetSocket    ( CHAR_DATA *ch, SOCKET_DATA *socket);
--- 73,80 ----
***************
*** 88,97 ****
  void         charSetRace      ( CHAR_DATA *ch, int race);
  void         charSetUID       ( CHAR_DATA *ch, int uid);
  void         charSetLoadroom  ( CHAR_DATA *ch, room_vnum loadroom);
- void         charSetVar       ( CHAR_DATA *ch, const char *var, int val);
  void         charSetFurniture ( CHAR_DATA *ch, OBJ_DATA *furniture);
  void         charSetPos       ( CHAR_DATA *ch, int pos);
- void         charSetAlias     ( CHAR_DATA *ch, const char *alias, const char *cmd);
  
  
  //*****************************************************************************
--- 91,98 ----
